;***************************************
;*                                     *
;*            Poing Ultra              *
;*    Written by Richard Bayliss       *
;*   For RETRO PROGRAMMERS INSIDE      *
;*          PONG Challenge             *
;*                                     *
;*     (C) 2022 The New Dimension      *
;*                                     *
;***************************************
;Format: 64TASS (PC based Turbo 
;Assembler compiler). 
;
;64TASS64 is available from.
;CSDB id: 204861
;
;ASSEMBLE WITH:
;64tass poingultra.asm -oname.prg

;CRUNCH WITH:
;exomizer sfx $3000 name.prg -o new.prg
;***************************************
;MAIN SOURCE FILE 
;(Use $3000 as jump address)
;***************************************

		;Include variables/constants
		.include "variables.asm"
		
		;Import title screen charset 
		*= $0800 
		.binary "c64/charset2x2.prg",2
		
		;Import in game music 
		*= $1000
		.binary "c64/gamemusic.prg",2
		
		;Import game sprites 
		*= $2000
		.binary "c64/sprites.prg",2
		
		;Import 1x1 text and game chars
		*= $2800
		.binary "c64/charset.prg",2
		
		;Include main game code and 
		;startup routines.
		*= $3000
		.include "gamecode.asm"
		
		;Import title screen flip text 
		;*= $4000
cycletext
		.binary "c64/cycletext.prg",2
		
		;Import title screen options 
		;text.
		;*= $4200
optiontxt		
		.binary "c64/optionstext.prg",2
		*=$4800
		;Import game graphics screen 
		;matrix
gamemap
		.binary "c64/gamescreen.prg",2
		
		;Import game graphics colour 
		;matrix 
gamecol 
		.binary "c64/gamecolour.prg",2
		
		;Inclue title screen code 
		*= $5000
		.include "titlecode.asm"
		
		;Import scrolling void charsets 
		*=$5800
voidchars
		.binary "c64/voidchars.prg",2
		
		
		;Import Koala Paint 
		;logo bitmap.		
		*= $6000
		.binary "c64/bitmaplogo.prg",2
		
		;Title screen scrolltext 
		*=$7000
scrolltext
		.binary "c64/scrolltext.prg",2
		;Import title music 
		*=$9000
		.binary "c64/titlemusic.prg",2
		
		